$(document).ready(function(){
	$('.inpnum').keydown(function(evt) {
		evt = (evt) ? evt : ((window.event) ? event : null);

		if (evt)
		{
			var elem = (evt.target)
			? evt.target
			:(
			  evt.srcElement
			  ? evt.srcElement
			  :null
			);
		 
			if (elem)
			{
				var charCode = evt.charCode
				?evt.charCode
				:(evt.which
				  ?evt.which
				  :evt.keyCode
				  );
		 
				if ((charCode < 32 ) ||
					(charCode > 44 && charCode < 47) || 
					(charCode > 95 && charCode < 106) || 
					(charCode > 47 && charCode < 58) || charCode == 188 || charCode == 191 || charCode == 190  || charCode == 110)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}
	});
	$('.inp_maxlength').keyup(function() {
		$(this).next(".maxlength").text($(this).attr("maxlength") - $(this).val().length);
	});

	$('.show_other_block').click(function() {
		$('.other').toggle();
	});
	$('.tab_card_title a').click(function() {
		$('.tab_card_title').removeClass("tab_card_title_active");
		$('.tab_card').hide();
		$('#'+$(this).attr("rel")).show("show");
		$(this).parents('.tab_card_title').addClass("tab_card_title_active");
		document.cookie = "tab_card_active=" + $(this).attr("rel");
	});
	$('.show_tr_click_checkbox').click(function() {
		show_tr_click_checkbox($(this));
	});
	$('.show_tr_click_checkbox').each(function() {
		show_tr_click_checkbox($(this));
	});
	$('.show_select_div').change(function() {
		show_select_div($(this));
	});
	$('.show_select_div').each(function() {
		show_select_div($(this));
	});
	$('select.redirect').change(function() {
		var path = $(this).attr("rel");
		if ($(this).val())
		{
			path = path+$(this).attr("name")+$(this).val()+'/';
		}
		window.location.href = path;
	});
        
        var last_tab;
	$('.show_tab_mini').click(function() {
		$('.'+$(this).attr("rel")).show();
                if(last_tab) $(last_tab).hide();
                if(last_tab!='.'+$(this).attr("rel")) last_tab='.'+$(this).attr("rel");
	});
	$('.check_price input[type=checkbox]').click(function() {
		if ($(this).attr("checked"))
		{
			$('.check_price').hide();
			$('.price_param').hide();
			$('.select_param').show();
			$('.check_price').attr("checked", "");

			$(this).attr("checked", 'checked');
			$(this).parents('.check_price').show();
			$('#price_param_'+$(this).attr('rel')).show();
			$('#select_param_'+$(this).attr('rel')).hide();
			$('#price').hide();
		}
		else
		{
			$('.check_price').show();
			$('#price_param_'+$(this).attr('rel')).hide();
			$('#select_param_'+$(this).attr('rel')).show();
			$('#price').show();
		}
	});

	$('input[name=file_type]').change(function() {
		$('.file_type1').hide();
		$('.file_type2').hide();
		$('.file_type3').hide();
		$('.file_type'+$(this).val()).show();
	});

	$(".tr").mouseover(function() {
		$(this).css('backgroundColor', $(this).attr("altcolor"));
		$(this).find(".actions span").show();
	});

	$(".tr").mouseout(function() {
		$(this).css('backgroundColor', '');
		$(this).find(".actions span").hide();
	});
	
	$(".actions a, .restore-action a").click(function() {
		var self = $(this);
		if (! self.attr("action"))
		{
			return true;
		}
		if (self.attr("confirm") && ! confirm(self.attr("confirm")))
		{
			return false;
		}
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : { action: self.attr("action"), id : self.parents("tr").find(".actions").attr("row_id"), check_hash_user : $('.check_hash_user').text()},
			success : (function(response)
			{
				if (response.redirect)
				{
					window.location.href = response.redirect;
				}
			})
		});
		return false;
	});

	$(".group_actions a").click(function() {
		var ids = new Array;
		var i = 0;
		$(".checkbox input[type=checkbox]:checked").each(function(){
			ids[i] = $(this).val();
			i++;
		});
		var self = $(this);
		if (self.attr("confirm") && ! confirm(self.attr("confirm")))
		{
			return false;
		}
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : { action: self.attr("action"), ids : ids, check_hash_user : $('.check_hash_user').text()},
			success : (function(response)
			{
				if (response.redirect)
				{
					window.location.href = response.redirect;
				}
			})
		});
		window.location.href = path;
		return false;
	});

	$("input[name=check_all]").click(function(){
		$(".checkbox input[type=checkbox]").attr("checked", $(this).attr("checked"));
	});

	$('.user_center font a, .help_close a').click(function(){
		$('.help_top, .help').toggle();
	});
	
	if ($('input[name=check_hash_user]').length && $('input[name=check_hash_user]').val() != $('.check_hash_user').text())
	{
		$('input[name=check_hash_user]').val($('.check_hash_user').text());
	}

	$('.change_parent_id a').live('click', function(){
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : { action: 'parent', parent_id : $('.change_parent_id input[name=parent_id]').val(), check_hash_user : $('.check_hash_user').text()},
			success : (function(response)
			{
				$('.change_parent_id').after(prepare(response.data));
				$('.change_parent_id').remove();
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
		return false;
	});

	$('.change_sort a').live('click', function(){
		var self = $(this);
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : { action: 'sort', sort : self.attr("sort"), cat_id : self.attr("cat_id"), name : self.attr("sname"),
					 site_id : self.attr("site_id"), parent_id : self.attr("parent_id"), sort: self.attr("sort"),
					 check_hash_user : $('.check_hash_user').text()},
			success : (function(response)
			{
				$('.change_sort').after(prepare(response.data));
				$('.change_sort').remove();
				if (response.hash)
				{
					$('input[name=check_hash_user]').val(response.hash);
					$('.check_hash_user').text(response.hash);
				}
			})
		});
		return false;
	});

        $("table.list tbody").addClass('contents');
        $("table.list tbody.contents").sortable( {
                cursor: 'move',
                items: 'tr',
                stop:function(event, ui) {
                    var sort_ids={};
                    $(this).children().each(function(i) {
                        row_id=$(this).find(".actions").attr("row_id");
                        if(row_id) {
                            sort_ids[row_id]=i+1;
                        }
                    });

                    $.ajax({
			url : window.location.href,
			type : "POST",
			dataType : "json",
                        cache: false,
                        async:false,
			data : { action: "move", check_hash_user : $('.check_hash_user').text(), sort: sort_ids},
                        error: function(jqXHR, textStatus, errorThrown){ console.log(jqXHR); console.log(textStatus); },
			success: function (response) {
                                if (response.hash) {
                                    $('input[name=check_hash_user]').val(response.hash);
                                    $('.check_hash_user').text(response.hash);
				}

                                if(response.error || !response.status) { // произошла ошибка меняем все обратно
                                    $("table.list tbody.contents").sortable('cancel');
                                }
                        }

                    });
                }
	});

	$("table.list tbody.contents").disableSelection();
});

function prepare(string)
{
	string = str_replace('&lt;', '<', string);
	string = str_replace('&gt;', '>', string);
	string = str_replace('&amp;', '&', string);
	return string;
}

function str_replace(search, replace, subject, count)
{
	f = [].concat(search),
	r = [].concat(replace),
	s = subject,
	ra = r instanceof Array, sa = s instanceof Array;
	s = [].concat(s);
	if (count)
	{
		this.window[count] = 0;
	}
	for (i=0, sl=s.length; i < sl; i++)
	{
		if (s[i] === '')
		{
			continue;
		}
		for (j=0, fl=f.length; j < fl; j++)
		{
			temp = s[i]+'';
			repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
			s[i] = (temp).split(f[j]).join(repl);
			if (count && s[i] !== temp)
			{
				this.window[count] += (temp.length-s[i].length)/f[j].length;
			}
		}
	}
	return sa ? s : s[0];
}

function tab_active(title)
{
	if (document.cookie.length > 0 && document.cookie.indexOf('tab_card_active=') != -1)
	{
		var offset = document.cookie.indexOf('tab_card_active');
		if (offset != -1)
		{
			offset += 16;
			end = document.cookie.indexOf(";", offset)
			if (end == -1) {
				end = document.cookie.length;
			}
			title = unescape(document.cookie.substring(offset, end));
		}
	}
	$('.tab_card_title a[rel='+title+']').parents('.tab_card_title').addClass("tab_card_title_active");
	$('#'+title).show();
}

function show_tr_click_checkbox(check)
{
	var str_arr = check.attr("rel").split(',');
	$.each(str_arr, function(key, str){
		if (check.attr("checked"))
		{
			$(str).show();
		}
		else
		{
			$(str).hide();
			if ($(str).find('.show_tr_click_checkbox').length)
			{
				$(str).find('.show_tr_click_checkbox').each(function(){
					$(this).attr("checked", false);
					show_tr_click_checkbox($(this));
				});
			}
		}
	});
}

function show_select_div(select)
{
	if (select.val() == 1)
	{
		$('#'+select.attr("rel")).show();
	}
	else
	{
		$('#'+select.attr("rel")).hide();
	}
}

function show_div(div)
{
	$('#'+div).toggle();
}