<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_install
 *
 * Установка модуля "Обратная связь"
 */

$title = "Обратная связь";

$sql = array(
	"CREATE TABLE {feedback} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		language TINYINT(2) UNSIGNED NOT NULL DEFAULT '0',
		text TEXT NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY site_id (site_id)
	) CHARSET=utf8",
	
	"CREATE TABLE {feedback_param} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		type VARCHAR(20) NOT NULL DEFAULT '',
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		required ENUM('0', '1') NOT NULL DEFAULT '0',
		".multilang("textLANG TEXT NOT NULL DEFAULT '',")."
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8",

	"CREATE TABLE {feedback_param_element} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		value text NOT NULL DEFAULT '',
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		element_id  INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY param_id (param_id),
		KEY value (value(5))
	) CHARSET=utf8",

	"CREATE TABLE {feedback_param_select} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		value TINYINT(2) UNSIGNED NOT NULL DEFAULT '0',
		".multilang("nameLANG VARCHAR(50) NOT NULL DEFAULT '',")."
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY param_id (param_id)
	) CHARSET=utf8",

	"INSERT INTO {site} (id,
		".multilang("nameLANG,")."
		".multilang("titleLANG,")."
		".multilang("actLANG,")."
		sort, timeedit, addmodule) VALUES (
		12,
		".multilang("'".$title."',", "'Feedback',", "'',")."
		".multilang("'".$title."',", "'Feedback',", "'',")."
		".multilang("'1',")."
		'12',
		'".time()."',
		'feedback'
	);",

	"INSERT INTO {rewrite} (id, rewrite, module_name, element_id, site_id, cat_id, trash) VALUES (12, 'feedback', 'site', 0, 12, 0, '0')",

	"INSERT INTO {adminsite} (id, group_id, count_children, name, rewrite, text, act, numrow, sort) VALUES (
		37,
		'2',
		3,
		'Обратная связь',
		'feedback',
		'<p>Модуль аналогичен вопрос-ответ, за исключением возможности публиковать сообщения в пользовательской части сайта.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		759442,
		25
	);",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `act`, `numrow`, `sort`) VALUES (
		62,
		37,
		'1',
		'Сообщения',
		'feedback',
		'<p>Модуль аналогичен вопрос-ответ, за исключением возможности публиковать сообщения в пользовательской части сайта.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		52,
		37
	);",

	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (62, 37)",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `act`, `numrow`, `sort`) VALUES (
		38,
		37,
		'2',
		'Конструктор формы',
		'feedback/param',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		5248,
		38
	);",

	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (38, 37)",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `numrow`, `sort`) VALUES (
		39,
		37,
		'2',
		'Настройки',
		'feedback/config',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		797,
		39
	);",

	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (39, 37)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'security', '2')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'sendmailadmin', '1')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'add_message', '<div align=\"center\"><b>Спасибо за ваше сообщение!</b></div>')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'error_add_message', 'Невозможно добавить ваше сообщение.<br>Проверьте правильность ввода.')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'error_empty_fields', 'Пожалуйста, заполните обязательное поле:')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'subject', '%%title (%%url). Обратная связь')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'message', 'Здравствуйте!<br>Вы оставили сообщение в форме обратной связи на сайте %%title (%%url).<br><b>Сообщение:</b> %%message <br><b>Ответ:</b> %%answer')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'subject_admin', '%%title (%%url). Новое сообщение в рубрике Обратная связь')",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('feedback', 'message_admin', 'Здравствуйте, администратор сайта %%title (%%url)!<br>В рубрике Обратная связь появилось новое сообщение:<br>%%message')",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'add_message', '<div align=\"center\"><b>Thank you for your message!</b></div>', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'error_add_message', 'Impossible to add your message.<br>Сheсk if input data is correct.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'error_empty_fields', 'Your message is already in data base.', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'subject', 'Please, enter obligatory field:', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'subject_admin', '%%title (%%url). Feedback', 2)",

	"INSERT INTO {config} (`module_name`, `name`, `value`, `lang_id`) VALUES ('feedback', 'message_admin', 'Hello!<br>You added message on the web site %%title (%%url).<br><b>Message:</b> %%message<br><b>Answer:</b> %%answer', 2)",

	"INSERT INTO {feedback_param} (id, ".multilang("nameLANG,")." type, site_id, sort, required) VALUES (
		1,
		".multilang("'Ваше имя',", "'Your name',", "'',")."
		'text',
		12,
		9,
		'1'
	);",

	"INSERT INTO {feedback_param} (id, ".multilang("nameLANG,")." type, site_id, sort, required) VALUES (
		2,
		".multilang("'Ваш e-mail',", "'Your e-mail',", "'',")."
		'email',
		12,
		10,
		'1'
	);",

	"INSERT INTO {feedback_param} (id, ".multilang("nameLANG,")." type, site_id, sort, required) VALUES (
		3,
		".multilang("'Ваше сообщение',", "'Your message',", "'',")."
		'textarea',
		12,
		11,
		'1'
	);"
);
	
$example = array(
	"UPDATE {site} SET
		".multilang(
			"text='<p>Наш зоопарк гордится тем, что у нас одна из лучших систем обратной связи с нашими посетителями!</p>\r\n<p>Вы можете звонить по нашим телефонам, или отправьте сообщение из формы ниже, указав правильный почтовый ящик - и мы обязательно вам ответим!</p>'",
	
			", text2='<p>Our zoo is proud of that at us one of the best systems of a feedback with our visitors!<br /><br />You can call by our phones, or send the message from the form more low, having specified a correct mail box - and we necessarily will answer you!</p>'",
	
			""
		)."
	WHERE id=12",

	"INSERT INTO {feedback} (id, created, site_id) VALUES (
		1,
		'".(time()-86400*2)."',
		'12'
	);",

	"INSERT INTO {feedback} (id, created, site_id) VALUES (
		2,
		'".(time()-86400)."',
		'12'
	);",

	"INSERT INTO {feedback} (id, created, site_id) VALUES (
		3,
		'".time()."',
		'12'
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		1,
		'Георгий'
		1,
		1
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		2,
		'Георг',
		1,
		2
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		3,
		'Виолетта',
		1,
		3
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		4,
		'',
		2,
		1
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		5,
		'',
		2,
		2
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		6,
		'',
		2,
		3
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		10,
		'Спасибо, что вы есть!',
		3,
		1
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		11,
		'Были у вас на прошлой неделе. Все понравилось, только кролик нам на ногу наступил...',
		3,
		2
	);",

	"INSERT INTO {feedback_param_element} (id, value, param_id, element_id) VALUES (
		12,
		'Надо мной посмеялась ваша ехидна, не поползу к вам больше, пока она не извинится!',
		3,
		3
	);"
);

/**
 * Выполняет действия для основной установки модуля
 * 
 * @return void
 */
function module_basic_feedback()
{
	if (! is_dir(ABSOLUTE_PATH.USERFILES.'/feedback'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/feedback', 0777);
	}

	if (! is_dir(ABSOLUTE_PATH.USERFILES.'/feedback/files'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/feedback/files', 0777);
	}

	if (! is_dir(ABSOLUTE_PATH.USERFILES.'/feedback/imgs'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/feedback/imgs', 0777);
	}

	if (! is_dir(ABSOLUTE_PATH.USERFILES.'/feedback/imgs/small'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/feedback/imgs/small', 0777);
	}

	$text = 'Options -Indexes

<files *>
deny from all
</files>';

	$fp = fopen(ABSOLUTE_PATH.USERFILES.'/feedback/files/.htaccess', "w");
	fwrite($fp, $text);
	fclose($fp);
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_feedback()
{
	$module = 'feedback';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DROP TABLE {".$module."_param};");
	DB::query("DROP TABLE {".$module."_param_element};");
	DB::query("DROP TABLE {".$module."_param_select};");
	$site_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {site} WHERE addmodule='".$module."'");
	if ($site_ids)
	{
		DB::query("DELETE FROM {site} WHERE id IN (".$site_ids.")");
		DB::query("DELETE FROM {site_parents} WHERE element_id IN (".$site_ids.")");
		DB::query("DELETE FROM {rewrite} WHERE module_name='site' AND site_id IN (".$site_ids.");");
		$menu_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {menu} WHERE site_id IN ('".$site_ids."')");
		if ($menu_ids)
		{
			DB::query("DELETE FROM {menu} WHERE id IN (".$menu_ids.")");
			$menu_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {menu_parents} WHERE parent_id IN (".$menu_ids.")");
			if ($menu_child_ids)
			{
				DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_child_ids.")");
			}
			DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_ids.")");
		}
	}
	$menu_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {menu} WHERE module_name='".$module."'");
	if ($menu_ids)
	{
		DB::query("DELETE FROM {menu} WHERE id IN (".$menu_ids.")");
		$menu_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {menu_parents} WHERE parent_id IN (".$menu_ids.")");
		if ($menu_child_ids)
		{
			DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_child_ids.")");
		}
		DB::query("DELETE FROM {menu_parents} WHERE element_id IN (".$menu_ids.")");
	}
	DB::query("DELETE FROM {rewrite} WHERE module_name='".$module."';");
	$admin_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {adminsite} WHERE rewrite IN ('".$module."', '".$module."/config', '".$module."/param')");
	if ($admin_ids)
	{
		DB::query("DELETE FROM {adminsite} WHERE id IN (".$admin_ids.")");
		DB::query("DELETE FROM {adminsite_parents} WHERE element_id IN (".$admin_ids.")");
	}
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {attachments} WHERE module_name='".$module."';");
	$trash_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {trash} WHERE module_name='".$module."'");
	if ($trash_ids)
	{
		DB::query("DELETE FROM {trash} WHERE id IN (".$trash_ids.")");
		$trash_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {trash_parents} WHERE parent_id IN (".$trash_ids.")");
		if ($trash_child_ids)
		{
			DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_child_ids.")");
		}
		DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_ids.")");
	}

	$folders = array($module.'/files', $module.'/imgs/small', $module.'/imgs', $module);
	foreach ($folders as $folder)
	{
		if ($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$folder))
		{
			while (($file = readdir($dirr)) !== FALSE)
			{
				@unlink(ABSOLUTE_PATH.USERFILES.'/'.$folder.'/'.$file);
			}
			closedir($dirr);
		}
		rmdir(ABSOLUTE_PATH.USERFILES.'/'.$folder);
	}
}