<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_admin_config
 *
 * Конфигурирование модуля "Форум"
 */
class Forum_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	var $file = 'forum_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'nastr'                 => 'numtext',
			'format_date'           => 'function',
			'format_date'           => 'select',
			'hr1'					=> 'hr',
			'access_add'            => 'select',
			'premoderation_theme'   => 'checkbox',
			'premoderation_message' => 'checkbox',
			'hr2'					=> 'hr',
			'attachments'           => 'module'
		);

		$this->config_module = array(
			'config' => 1 //файл настроек модуля
		);

		$this->select_arr["access_add"] = array(
			0 => _ADMIN_FORUM_CONFIG_ACCESS_0,
			1 => _ADMIN_FORUM_CONFIG_ACCESS_1,
			2 => _ADMIN_FORUM_CONFIG_ACCESS_2
		);

		$this->select_arr["format_date"] = array(
			0 => _ADMIN_FORMAT_DATE_0,
			1 => _ADMIN_FORMAT_DATE_1,
			2 => _ADMIN_FORMAT_DATE_2,
			3 => _ADMIN_FORMAT_DATE_3,
			5 => _ADMIN_FORMAT_DATE_5,
			4 => _ADMIN_FORMAT_DATE_4
		);
	}
}