<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Images_admin_save
 * 
 * Сохранение полей, связанных с работой модуля "Изображения"
 */
class Images_admin_save
{
	/**
	 * Сохранение настроек конфигурации модулей
	 * 
	 * @return boolean true
	 */
	public static function save_config($th)
	{
		$category = FALSE;
		if (! empty($th->variable_table["cat"]))
		{
			$category = TRUE;
		}
		elseif (! empty($th->config_module["tab_card"]))
		{
			foreach ($th->variable_table as $v)
			{
				if (! empty($v["cat"]))
				{
					$category = TRUE;
				}
			}
		}
		if ($category)
		{
			$fileds = array('images', 'big_width', 'big_height', 'big_quality', 'medium_width', 'medium_height', 'medium_quality', 'list_img',
							'images_cat', 'big_width_cat', 'big_height_cat', 'big_quality_cat', 'medium_width_cat', 'medium_height_cat',
							'medium_quality_cat', 'list_img_cat', 'use_animation', 'watermark', 'watermark_only_big');
		}
		else
		{
			$fileds = array('images', 'big_width', 'big_height', 'big_quality', 'medium_width', 'medium_height', 'medium_quality', 'list_img',
							'use_animation', 'watermark', 'watermark_only_big');
		}
		foreach ($fileds as $filed)
		{
			$th->query[] = $filed."='%d'";
			$th->value[] = ! empty($_POST[$filed]) ? $_POST[$filed] : '';
		}
		$th->query[] = "watermark_path='%h'";
		$th->value[] = $th->diafan->configmodules("watermark_path");
		$th->query[] = "watermark_placement='%h'";
		$th->value[] = (in_array($_POST["watermark_placement_vertical"], array('bottom', 'middle')) ? $_POST["watermark_placement_vertical"] : 'middle')
		.'='.intval($_POST["watermark_placement_vertical_px"]).','
		.(in_array($_POST["watermark_placement_horizontal"], array('right', 'center')) ? $_POST["watermark_placement_horizontal"] : 'center')
		.'='.intval($_POST["watermark_placement_horizontal_px"]);
		return TRUE;
	}
}