<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_install
 *
 * Установка модуля "Опросы"
 */

$title = "Опросы";

$sql = array(
	"CREATE TABLE {votes} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG TEXT NOT NULL DEFAULT '',")."
		cat_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		count_votes INT(5) UNSIGNED NOT NULL DEFAULT '0',
		sort INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY cat_id (cat_id)
	) CHARSET=utf8",

	"CREATE TABLE {votes_category} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG TEXT NOT NULL DEFAULT '',")."
		".multilang("actLANG ENUM('0', '1') NOT NULL DEFAULT '0',")."
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		sort INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY site_id (site_id)
	) CHARSET=utf8",

	"INSERT INTO {adminsite} (id, group_id, count_children, name, rewrite, text, act, numrow, sort) VALUES (
		28,
		'2',
		1,
		'Опросы',
		'votes',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		628973,
		32
	);",

	"INSERT INTO {adminsite} (`id`, `parent_id`, `group_id`, `name`, `rewrite`, `text`, `numrow`, `sort`) VALUES (
		29,
		28,
		'2',
		'Настройки',
		'votes/config',
		'<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		5,
		29
	);",

	"INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (29, 28)",

	"INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('votes', 'security', '4')"
);

$example = array(
	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." sort) VALUES (
		1,
		".multilang("'Нравится ли Вам наш зоопарк?',", "'Whether our zoo is pleasant to you?',", "'',")."
		".multilang("'1',")."
		1
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		1,
		".multilang("'Да, очень!',", "'Yes, very much!',", "'',")."
		1,
		1,
		1
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		2,
		".multilang("'Сойдет',", "'Descend',", "'',")."
		1,
		2
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		3,
		".multilang("'Мне нейтрально',", "'To me it is neutral',", "'',")."
		1,
		3
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		4,
		".multilang("'Так себе',", "'So-so',", "'',")."
		1,
		4
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		5,
		".multilang("'Не нравится',", "'It is not pleasant',", "'',")."
		1,
		5
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." sort) VALUES (
		7,
		".multilang("'Каких животных Вы предпочитаете?',", "'You prefer what animals?',", "'',")."
		".multilang("'1',")."
		7
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		8,
		".multilang("'Травоядных',", "'Herbivorous',", "'',")."
		7,
		1,
		8
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		9,
		".multilang("'Хищников',", "'Predator',", "'',")."
		7,
		9
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		10,
		".multilang("'Не люблю животных',", "'I do not love animals',", "'',")."
		7,
		10
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		11,
		".multilang("'Всех',", "'All',", "'',")."
		7,
		1,
		11
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." sort) VALUES (
		13,
		".multilang("'Посещаете ли Вы со своим питомцем ветеринарные клиники?',", "'Whether you with the pupil visit veterinary clinics?',", "'',")."
		".multilang("'1',")."
		13
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		14,
		".multilang("'Постоянно',", "'Regularly',", "'',")."
		13,
		14
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		15,
		".multilang("'В крайних случаях',", "'In extreme cases',", "'',")."
		13,
		15
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		16,
		".multilang("'Никогда',", "'Never',", "'',")."
		13,
		16
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." site_id, sort) VALUES (
		18,
		".multilang("'Сколько денег Вы тратите в месяц на своего домашнего питомца?',", "'How many money you spend in a month for the house pupil?',", "'',")."
		".multilang("'1',")."
		3,
		18
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		19,
		".multilang("'до 100 руб.',", "'To 100 rbl.',", "'',")."
		18,
		19
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		20,
		".multilang("'от 100 руб. до 450 руб.',", "'From 100 rbl. to 450 rbl.',", "'',")."
		18,
		20
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		21,
		".multilang("'более 500 руб.',", "'More than 500 rbl.',", "'',")."
		18,
		21
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		22,
		".multilang("'Вообще не трачу денег',", "'At all I do not spend money',", "'',")."
		18,
		22
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." site_id, sort) VALUES (
		23,
		".multilang("'Нужны ли бумажные зоопарки?',", "'Whether paper zoos are necessary?',", "'',")."
		".multilang("'1',")."
		1,
		23
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		24,
		".multilang("'Кому-то нечем заняться',", "'Someone has nothing to be engaged',", "'',")."
		23,
		1,
		24
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		25,
		".multilang("'Да. Это очень интересно',", "'Yes. It is very interesting',", "'',")."
		23,
		25
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		26,
		".multilang("'Бумажные зоопарки никому не нужны',", "'Paper zoos are necessary to nobody',", "'',")."
		23,
		26
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		27,
		".multilang("'Такие зоопарки поднимают настроение',", "'Such zoos cheer up',", "'',")."
		23,
		27
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." site_id, sort) VALUES (
		28,
		".multilang("'Купили бы Вы бумажную таксу?',", "'You would buy the paper turnspit?',", "'',")."
		".multilang("'1',")."
		3,
		28
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		29,
		".multilang("'Нет, пустая трата денег',", "'No, waste of money',", "'',")."
		28,
		29
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		30,
		".multilang("'Да, она украсила бы мою комнату',", "'Yes, it would decorate my room',", "'',")."
		28,
		30
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		31,
		".multilang("'Конечно, оригинальный подарок',", "'Certainly, an original gift',", "'',")."
		28,
		31
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		32,
		".multilang("'С удовольствием, хоть поговорить будет с кем',", "'With pleasure though will talk to whom',", "'',")."
		28,
		32
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." sort) VALUES (
		33,
		".multilang("'Часто ли коты греются в Вашем подъезде?',", "'Whether often cats are heated at your entrance?',", "'',")."
		".multilang("'1',")."
		33
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		34,
		".multilang("'Постоянно',", "'Regularly',", "'',")."
		33,
		34
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		35,
		".multilang("'У меня нет подъезда',", "'I do not have entrance',", "'',")."
		33,
		35
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		36,
		".multilang("'Да, но мне не жалко, пусть греются',", "'Yes, but it is not a pity to me, let are heated',", "'',")."
		33,
		1,
		36
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, count_votes, sort) VALUES (
		37,
		".multilang("'Теперь нет. Мы всем подъездом их выгнали',", "'Now is not present. All of us an entrance have expelled them',", "'',")."
		,33,
		1,
		37
	);",

	"INSERT INTO {votes_category} (id,".multilang(" nameLANG,").multilang(" actLANG,")." sort) VALUES (
		38,
		".multilang("'Кажется ли Вам, что животные следят за Вами?',", "'Whether it seems to you, what animals watch you?',", "'',")."
		".multilang("'1',")."
		38
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		39,
		".multilang("'Мне постоянно кажется это',", "'It constantly seems to me',", "'',")."
		38,
		39
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		40,
		".multilang("'Нет, за мной следят только люди',", "'No, I am watched only by people',", "'',")."
		38,
		40
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		41,
		".multilang("'Да, а вы откуда знаете это?',", "'Yes, and you whence know it?',", "'',")."
		38,
		41
	);",

	"INSERT INTO {votes} (id,".multilang(" nameLANG,")." cat_id, sort) VALUES (
		42,
		".multilang("'Мне уже ничего не кажется',", "'Already it seems nothing to me',", "'',")."
		38,
		42
	);"
);

/**
 * Выполняет действия по установке модуля
 * 
 * @return void
 */
function module_basic_votes()
{
	$url = parse_url(DB_URL);
	$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
	while ($row = mysql_fetch_row($result))
	{
		if ($row[0] == DB_PREFIX."log_note") return false;
	}

	DB::query(
	"CREATE TABLE {log_note} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		module_name VARCHAR(10) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		note INT(7) UNSIGNED NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		ip VARCHAR(62) NOT NULL DEFAULT '',
		session_id VARCHAR(64) NOT NULL DEFAULT '',
		include_name VARCHAR(10) NOT NULL DEFAULT '',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY session_id (session_id(2)),
		KEY include_name (include_name(2)),
		KEY module_name (module_name(2))
	) CHARSET=utf8");
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_votes()
{
	$module = 'votes';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DROP TABLE {".$module."_category};");
	$admin_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {adminsite} WHERE rewrite IN ('".$module."', '".$module."/config')");
	if ($admin_ids)
	{
		DB::query("DELETE FROM {adminsite} WHERE id IN (".$admin_ids.")");
		DB::query("DELETE FROM {adminsite_parents} WHERE element_id IN (".$admin_ids.")");
	}
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {log_note} WHERE module_name='".$module."';");
	$trash_ids = DB::query_result("SELECT GROUP_CONCAT(id SEPARATOR ',') FROM {trash} WHERE module_name='".$module."'");
	if ($trash_ids)
	{
		DB::query("DELETE FROM {trash} WHERE id IN (".$trash_ids.")");
		$trash_child_ids = DB::query_result("SELECT GROUP_CONCAT(element_id SEPARATOR ',') FROM {trash_parents} WHERE parent_id IN (".$trash_ids.")");
		if ($trash_child_ids)
		{
			DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_child_ids.")");
		}
		DB::query("DELETE FROM {trash_parents} WHERE element_id IN (".$trash_ids.")");
	}
}