<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Attachments_admin_save
 * 
 * Сохранение полей, связанных с работой модуля "Прикрепленные файлы"
 */
class Attachments_admin_save
{
	/**
	 * Сохранение поля "Прикрепленные файлы"
	 * 
	 * @return boolean true
	 */
	public static function save(&$th)
	{
		$result = DB::query("SELECT id FROM {attachments} WHERE module_name='".$th->table."' AND element_id='%d'", $th->diafan->save);
		while ($row = DB::fetch_array($result))
		{
			if (! empty($_POST["filedel"]) && in_array($row["id"], $_POST["filedel"]))
			{
				$th->diafan->_attachments->delete($th->diafan->save, $th->table, $row["id"]);
			}
		}

		if (isset($_FILES["attachment"]) && is_array($_FILES["attachment"]) && $_FILES["attachment"]['name'] != '')
		{
			$err = $th->diafan->_attachments->upload($_FILES['attachment'], $th->table, $th->diafan->save);

			if (! empty($err))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}
		}

		return TRUE;
	}

	/**
	 * Сохранение настроек конфигурации модулей
	 * 
	 * @return boolean true
	 */
	public static function save_config(&$th)
	{
		$fileds = array('attachments', 'max_count_attachments', 'attachment_extensions', 'recognize_image', 'attach_big_width', 'attach_big_height',
		                'attach_big_quality', 'attach_medium_width', 'attach_medium_height', 'attach_medium_quality', 'use_animation');
		foreach ($fileds as $filed)
		{
			$th->query[] = $filed."='%h'";
			$th->value[] = ! empty($_POST[$filed]) ? $_POST[$filed] : '';
		}
		$th->query[] = "attachment_extensions='%h'";
		$th->value[] = ! empty($_POST["attachment_extensions"]) ? $_POST["attachment_extensions"] : '';
		return TRUE;
	}
}