<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * News_admin_config
 *
 * Конфигурирование модуля "Новости"
 */
class News_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'news_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'nastr'              => 'numtext',
			
			'hr1'                => 'hr',
			'format_date'        => 'select',
			
			'hr2'                => 'hr',
			'cat'                => 'checkbox',
			'count_list'         => 'numtext',
			'childrens_elements' => 'checkbox',

			'hr3'                => 'hr',
			'images'             => 'module',

			'hr4'                => 'hr',
			'comments'           => 'module',
			'tags'               => 'module',
			'rating'             => 'module'
		);

		$this->config_module = array(
			'element_site' => 1, //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'config'       => 1  //файл настроек модуля
		);

		$this->select_arr["format_date"] = array(
			0 => _ADMIN_FORMAT_DATE_0,
			1 => _ADMIN_FORMAT_DATE_1,
			2 => _ADMIN_FORMAT_DATE_2,
			3 => _ADMIN_FORMAT_DATE_3,
			4 => _ADMIN_FORMAT_DATE_4
		);

		$this->show_tr_click_checkbox=array(
			'cat' => array(
				'count_list',
				'childrens_elements'
			)
		);
	}
}