<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.4
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

include (ABSOLUTE_PATH."modules/order/num2str.php");

/**
 * Обработка данных, полученных от системы WebMoney
 */

// проверка валидности запроса
if ($_GET["rewrite"] == "wm/result")
{
	if (! isset($_POST['LMI_PREREQUEST']) || $_POST['LMI_PREREQUEST'] != 1)
	{
	
		if (! isset($_POST['LMI_PAYMENT_NO']) || preg_match('/^\d+$/', $_POST['LMI_PAYMENT_NO']) != 1 || ! isset($_POST['RND'])
		   || preg_match('/^[A-Z0-9]{8}$/', $_POST['RND'], $match) != 1)
		{
			include(ABSOLUTE_PATH."includes/404.php");
		}
	
		$pay = DB::fetch_array(DB::query("SELECT o.id FROM {shop_payment} as p, {shop_order} as o"
			     ." WHERE o.id ='%d' AND p.order_id = o.id AND p.state='I' AND o.status='0'"
			     ." AND RND='%s' AND o.summ='%f'",
			     $_POST['LMI_PAYMENT_NO'], $_POST['RND'], $_POST['LMI_PAYMENT_AMOUNT']
			     ));
		if (!$pay)
		{
			include(ABSOLUTE_PATH."includes/404.php");
		}

		DB::query("UPDATE {shop_payment} SET state='R' WHERE order_id='%d'", $_POST['LMI_PAYMENT_NO']);
		echo 'YES';
	}
	else
	{

		if (! isset($_POST['LMI_PAYMENT_NO'])
		   || preg_match('/^\d+$/', $_POST['LMI_PAYMENT_NO']) != 1
		   || !isset($_POST['RND']) || preg_match('/^[A-Z0-9]{8}$/', $_POST['RND'], $match) != 1)
		{
			include(ABSOLUTE_PATH."includes/404.php");
		}
	
		$pay = DB::fetch_array(DB::query("SELECT o.id, o.summ FROM {shop_payment} as p, {shop_order} as o"
			     ." WHERE o.id ='%d' AND p.order_id = o.id AND p.state='R' AND o.status='1'"
			     ." AND RND='%s' AND o.summ='%f'",
			     $_POST['LMI_PAYMENT_NO'], $_POST['RND'], $_POST['LMI_PAYMENT_AMOUNT']
			     ));
		if (! $pay)
		{
			include(ABSOLUTE_PATH."includes/404.php");
		}
		
		$values=my_json_decode(DB::query_result("SELECT m.module_values FROM {shop_payment_method} AS m, {shop_order} AS p WHERE p.id='%d' AND m.id = p.payment",$_POST['LMI_PAYMENT_NO']));
		
		$chkstring = $values['wm_target']
			.$pay['summ']
			.$pay['id']
			.$_POST['LMI_MODE']
			.$_POST['LMI_SYS_INVS_NO']
			.$_POST['LMI_SYS_TRANS_NO']
			.$_POST['LMI_SYS_TRANS_DATE']
			.$values['wm_secret']
			.$_POST['LMI_PAYER_PURSE']
			.$_POST['LMI_PAYER_WM'];
		$md5sum = strtoupper(md5($chkstring));

		if ($_POST['LMI_PAYEE_PURSE'] != $values['wm_target'] || $_POST['LMI_HASH'] != $md5sum)
		{
			include(ABSOLUTE_PATH."includes/404.php");
		}
		DB::query("UPDATE {shop_payment} SET state='S', timestamp=CURRENT_TIMESTAMP(), LMI_SYS_INVS_NO='%s',"
		          ." LMI_SYS_TRANS_NO='%s', LMI_SYS_TRANS_DATE='%s', LMI_PAYER_PURSE='%s', LMI_PAYER_WM='%s'"
		          ." WHERE order_id='%d'",
			  $_POST['LMI_SYS_INVS_NO'], $_POST['LMI_SYS_TRANS_NO'], $_POST['LMI_SYS_TRANS_DATE'],
			  $_POST['LMI_PAYER_PURSE'], $_POST['LMI_PAYER_WM'], $pay['id']
		);
	}
	exit;
}

// оплата прошла успешно
if ($_GET["rewrite"] == "wm/success")
{
	if (!isset($_POST['LMI_PAYMENT_NO']) || preg_match('/^\d+$/', $_POST['LMI_PAYMENT_NO']) != 1)
	{
		include(ABSOLUTE_PATH."includes/404.php");
	}

	$pay = DB::result(DB::query("SELECT o.id FROM {shop_payment} as p, {shop_order} as o"
					." WHERE o.id=%d AND p.order_id=o.id AND o.status='0' AND p.state='S'"
					." AND p.LMI_SYS_INVS_NO='%s' AND p.LMI_SYS_TRANS_NO='%s' AND p.LMI_SYS_TRANS_DATE='%s' AND p.RND='%s'",
					$_POST['LMI_PAYMENT_NO'], $_POST['LMI_SYS_INVS_NO'], $_POST['LMI_SYS_TRANS_NO'],
					$_POST['LMI_SYS_TRANS_DATE'], $_POST['RND']
					));
	if (! $pay)
	{
		include(ABSOLUTE_PATH."includes/404.php");
	}

	// меняем статус заказа на "В обработке"
	DB::query("UPDATE {shop_payment} SET state='G', timestamp=CURRENT_TIMESTAMP() WHERE id='%d'", $_POST['LMI_PAYMENT_NO']);
	DB::query("UPDATE {shop_order} SET status='1' WHERE id=%d", $_POST['LMI_PAYMENT_NO']);
	if ($this->configmodules("use_count_goods", "shop"))
	{
		$result = DB::query("SELECT * FROM {shop_order_goods} WHERE order_id=%d", $_POST['LMI_PAYMENT_NO']); 
		while ($row = DB::fetch_array($result))
		{
			if ($row["count_goods"])
			{
				$count = DB::query_result("SELECT count_goods FROM {shop_price} WHERE good_id=%d AND param_value='%d'", $row["good_id"], $row["depend_price"]);
				$count = $count > $row["count_goods"] ? $count - $row["count_goods"] : 0;
				// уменьшаем количество товаров на складе
				DB::query("UPDATE {shop_price} SET count_goods=%d WHERE good_id=%d AND param_value='%d'", $count, $row["good_id"], $row["depend_price"]);

				// заносим операцию в отчет
				DB::query("INSERT INTO {shop_order_count_goods} (created, order_id, good_id, count_goods, summ, param_value, type, user_id)"
				          ." VALUES (%d, %d, %d, %d, %f, %d, 'user', %d)", time(), $row["order_id"], $row["good_id"], $row["count_goods"],
				          $row["count_goods"] * $row["price"], $row["depend_price"], $this->_user->id);
			}
		}
	}

	$order_rew = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND trash='0' AND site_id IN"
	                              ." (SELECT id FROM {site} WHERE addmodule='order' AND act='1' AND trash='0' AND block='0')");
	$this->redirect('http://'.$_SERVER["HTTP_HOST"].'/'.(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').$order_rew.'/step5/');
	exit;
}

// оплата отменена
if ($_GET["rewrite"] == "wm/fail")
{
	if (! isset($_POST['LMI_PAYMENT_NO']) || preg_match('/^\d+$/', $_POST['LMI_PAYMENT_NO']) != 1)
	{
		include(ABSOLUTE_PATH."includes/404.php");
	}

    $pay = DB::fetch_array(DB::query("SELECT id  FROM {shop_payment} WHERE order_id ='%d' AND RND='%s'", $_POST['LMI_PAYMENT_NO'], $_POST['RND']));
	if (! $pay)
	{
		include(ABSOLUTE_PATH."includes/404.php");
	}
	DB::query("UPDATE {shop_order} SET status='2' WHERE id='%d'", $_POST['LMI_PAYMENT_NO']);
	DB::query("UPDATE {shop_payment} SET state='F', timestamp=CURRENT_TIMESTAMP() WHERE id='%d'", $pay['id']);

	$order_rew = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND trash='0' AND site_id IN"
				      ." (SELECT id FROM {site} WHERE addmodule='order' AND act='1' AND trash='0' AND block='0')");
	$this->redirect('http://'.$_SERVER["HTTP_HOST"].'/'.(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').$order_rew.'/step6/');
	exit;
}

include(ABSOLUTE_PATH."includes/404.php");