<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration
 *
 * Контроллер модуля "Регистрация"
 */
class Registration extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('step');
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;

		
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean
	 */
	function show_module()
	{
		if (! empty($this->result["actlink"]))
		{
			echo $this->result["actlink"];
			return FALSE;
		}
                
                
                
                $model = new Registration_model($this->diafan);
                
		$this->result = $model->form();
                $this->diafan->_tpl->get('form', 'registration', $this->result);
                
                
                if($this->diafan->_user->id) {
                $this->result = $model->order();
                $this->diafan->_tpl->get('order', 'registration', $this->result);
                }
                
                
		return TRUE;
	}

	/**
	 * Шаблонная функция: форма авторизации
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	function show_login($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'template');

		include_once(ABSOLUTE_PATH.'modules/registration/registration.model.php');
		$model = new Registration_model($this->diafan);
		$result = $model->show_login();

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_login_'.$attributes["template"], 'registration', $result))
		{
			echo $this->diafan->_tpl->get('show_login', 'registration', $result);
		}
		return TRUE;
	}  	
}