<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags
 *
 * Контроллер модуля "Тэги"
 */
class Search extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page');

		$model = new Search_model($this->diafan);
		$this->result = $model->show_module();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get('show_module', 'search', $this->result);

		return TRUE;
	}

	/**
	 * Шаблонная функция: форма поиска по сайту
	 * 
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean true
	 */
	public function show_search($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'button', 'button'._LANG, 'template');
		
		$button = $attributes["button"._LANG] ? $attributes["button"._LANG] : $attributes["button"];

		include_once(ABSOLUTE_PATH.'modules/search/search.model.php');
		$model = new Search_model($this->diafan);
		$result = $model->show_search($button);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_search_'.$attributes["template"], 'search', $result))
		{
			$this->diafan->_tpl->get('show_search', 'search', $result);
		}

		return TRUE;
	}
}