<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include(dirname(dirname(dirname(__FILE__))) . '/includes/404.php');
}

/**
 * Shop_admin_discount
 *
 * Скидки
 */
class Shop_admin_delivery extends Frame_admin {

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shopdelivery';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop_delivery';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan) {
        $this->diafan = $diafan;

        //поля в базе данных для редактирования
        $this->variable_table = array(
            'name' => 'text',
            'price' => 'floattext',
            'amount' => 'floattext',
            'act'=>'checkbox',
            'text' => 'textarea'
        );

        $this->config_module = array(
            'del' => 1, //удалить
            'act' => 1,
            'trach' => 1,
            'order'            => 1 //сортируется
        );
    }

    /**
     * Выводит список заказов
     * @return boolean true
     */
    public function show_module() {

        $this->addnew_init(_LANG_ADD);
        echo '<table class="list">';
        $this->list_row();
        echo '</table>';
        return TRUE;
    }

}