<?php /**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.5
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

define('DIAFAN', 1);
include_once(dirname(__FILE__)."/config.php");


if (defined('VERSION_CMS') && VERSION_CMS == '4.5')
{
	include(dirname(__FILE__)."/includes/404.php");
}

define('IS_ADMIN', 1);
define('IS_INSTALL', 1);

error_reporting(0);

define("VERSION", "4.5");
define("D_UPDATE", "1329306060");
define("ABSOLUTE_PATH", dirname(__FILE__)."/");

include_once(ABSOLUTE_PATH.'includes/function.php');
include_once(ABSOLUTE_PATH.'includes/http.php');
include_once(ABSOLUTE_PATH.'includes/https.php');
include_once(ABSOLUTE_PATH.'includes/xml.php');
include_once(ABSOLUTE_PATH.'includes/core.php');
require_once(ABSOLUTE_PATH.'includes/database.php');
require_once(ABSOLUTE_PATH.'includes/session.php');
require_once(ABSOLUTE_PATH.'includes/user.php');
include_once(ABSOLUTE_PATH.'includes/init.php');

$diafan = new Init();

$language = array();
$result = DB::query("SELECT id FROM {language}");
while ($row = DB::fetch_array($result))
{
    $language[] = $row["id"] != 1 ? $row["id"] : '';
}


$sql=array(
    // новые таблицы
    'new_table'=>array("CREATE TABLE IF NOT EXISTS {comments_param} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(250) NOT NULL DEFAULT '',
		type VARCHAR(20) NOT NULL DEFAULT '',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		required ENUM('0', '1') NOT NULL DEFAULT '0',
		text text NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	) CHARSET=utf8",
	
	"CREATE TABLE IF NOT EXISTS {comments_param_element} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		value text NOT NULL DEFAULT '',
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY param_id (param_id),
		KEY value (value(5))
	) CHARSET=utf8",	
	"CREATE TABLE IF NOT EXISTS {comments_param_select} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		param_id int(11) unsigned NOT NULL default '0',
		value tinyint(2) unsigned NOT NULL default '0',
		name varchar(50) NOT NULL default '',
		sort int(11) unsigned NOT NULL default '0',
		trash enum('0','1') NOT NULL default '0',
		PRIMARY KEY (id),
		KEY param_id (param_id)
	) CHARSET=utf8",
        	"CREATE TABLE IF NOT EXISTS {shop_delivery} (
		`id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`name` text NOT NULL,
		`price` float NOT NULL default '0',
		`amount` float NOT NULL default '0',
		`text` text NOT NULL,
		`act` enum('0','1') NOT NULL default '0',
		`sort` int(10) unsigned NOT NULL default '0',
		`trash` enum('0','1') NOT NULL default '0',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8",
        	"CREATE TABLE IF NOT EXISTS {shop_payment_method} (
		`id` int(11) unsigned NOT NULL auto_increment,
		`name` varchar(50) NOT NULL,
		`text` text NOT NULL,
		`module_values` text NOT NULL,
		`trash` enum('0','1') NOT NULL default '0',
		`act` enum('0','1') NOT NULL default '0',
		`sort` int(11) unsigned NOT NULL default '0',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8",
        	"CREATE TABLE IF NOT EXISTS {shop_order_param_def} (
		`id` int(11) unsigned NOT NULL auto_increment,
		`value` text NOT NULL,
		`param_id` int(11) unsigned NOT NULL default '0',
		`user_id` int(11) unsigned NOT NULL default '0',
		`trash` enum('0','1') NOT NULL default '0',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8",
        	"CREATE TABLE IF NOT EXISTS {shop_discount_type} (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`name` VARCHAR(255) NOT NULL DEFAULT '',
		PRIMARY KEY  (`id`)
	) CHARSET=utf8",
        ),

    // новые поля в старых таблицах
    'new_rows'=>array("ALTER TABLE {shop} ADD `view` INT(11) UNSIGNED NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop} ADD `buy` INT(11) UNSIGNED NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop_order} ADD `delivery` INT(11) UNSIGNED NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop_order_param} ADD `def` ENUM('0', '1') NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop_discount} ADD `amount` FLOAT NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop_discount} ADD `deduction` FLOAT NOT NULL DEFAULT '0'",
        "ALTER TABLE {shop_discount} ADD `type` INT( 5 ) UNSIGNED NOT NULL DEFAULT '0'",
        "ALTER TABLE {site} ADD `is_menu` ENUM('0', '1') NOT NULL DEFAULT '0'"
        ),

    //новые значения в конфиге
    'new_config'=>array("INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('news', 'count_list', '3')",
        "INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('faq', 'count_list', '3')",
        "INSERT INTO {config} (`module_name`, `name`, `value`) VALUES ('comments', 'error_empty_fields', 'Не заполнены обязательные поля')"
        ),
    
    //новые записи
    'new_insert'=>array(
        "INSERT INTO {shop_delivery} (`id`, `name`, `price`, `amount`, `text`, `act`, `sort`, `trash`) VALUES (1, 'Самовывоз', 0, 0, 'Товар необходимо забрать с нашего склада', '1', 1, '0')",
	"INSERT INTO {shop_payment_method} (`id`, `name`, `text`, `module_values`, `trash`, `act`, `sort`) VALUES (1, 'Наличными курьеру', '<p>Оплатите товар курьеру на руки наличными</p>', '', '0', '1', 1)",
	"INSERT INTO {shop_discount_type} (`id`, `name`) VALUES (1, 'Покупатель'), (2, 'Мелкий оптовик'), (3, 'Крупный оптовик')"
        )
);

// выполняем запросы
foreach($sql as $types)
    foreach($types as $query)
        if(!DB::query($query)) print mysql_error()."<br>";

// обновляем админку
// конструктор формы комментариев
$id_parent=DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='comments' LIMIT 1");
DB::query("INSERT INTO {adminsite} (`parent_id`, `group_id`, `name`, `rewrite`, `text`, `numrow`,`sort`) VALUES ('%d','2','Конструктор формы','comments/param','<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',3429843,69)",$id_comments);
$id_new=DB::next_id('adminsite');
DB::query("INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (%d, %d)",$id_new,$id_parent);

// типы покупателей
$id_parent=DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='shop/discount' LIMIT 1");
DB::query("INSERT INTO {adminsite} (`parent_id`, `group_id`, `name`, `rewrite`, `text`, `act`, `numrow`,`sort`) VALUES ('%d','1','Типы покупателей','shop/discount/type','<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>','1',85478,70)",$id_parent);
$id_new=DB::next_id('adminsite');
DB::query("INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (%d, %d)",$id_new,$id_parent);

// способы доставки
$id_parent=DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='shop' LIMIT 1");
DB::query("INSERT INTO {adminsite} (`parent_id`, `group_id`, `name`, `rewrite`, `text`, `act`, `numrow`,`sort`) VALUES ('%d','1','Способы доставки','shop/delivery','<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>','1',4283516,71)",$id_parent);
$id_new=DB::next_id('adminsite');
DB::query("INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (%d, %d)",$id_new,$id_parent);

// методы оплаты
DB::query("INSERT INTO {adminsite} (`parent_id`, `group_id`, `name`, `rewrite`, `text`, `act`, `numrow`,`sort`) VALUES ('%d','1','Методы оплаты','shop/payment','<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>','1',526,72)",$id_parent);
$id_new=DB::next_id('adminsite');
DB::query("INSERT INTO {adminsite_parents} (`element_id`, `parent_id`) VALUES (%d, %d)",$id_new,$id_parent);

//////////////////////config
$new_values = array(
		'VERSION_CMS' => VERSION,
		'DATE_UPDATE' => D_UPDATE
	);
$lang = array();
foreach ($language as $l)
{
	$lang[] = array($l);
}
include_once(ABSOLUTE_PATH.'includes/config.php');
Config::save($new_values, $lang);



echo '<font color="green">Обновление успешно завершено!</font>';
